"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskRequestsController = void 0;
const common_1 = require("@nestjs/common");
const create_task_request_dto_1 = require("./dto/create-task-request.dto");
const task_requests_service_1 = require("./task-requests.service");
const update_task_request_dto_1 = require("./dto/update-task-request.dto");
let TaskRequestsController = class TaskRequestsController {
    // eslint-disable-next-line no-unused-vars
    constructor(taskRequestsService) {
        this.taskRequestsService = taskRequestsService;
        this.logger = new common_1.Logger('TaskRequestsController');
    }
    findOne(params) {
        return this.taskRequestsService.findOne(params.id);
    }
    findAll(status, limit) {
        let result = [];
        if (status) {
            result = this.taskRequestsService.findAllByStatus(status);
        }
        else {
            result = this.taskRequestsService.findAll();
        }
        if (limit && limit > 0) {
            result = result.slice(0, limit);
        }
        return result;
    }
    create(createTaskRequestDto) {
        return this.taskRequestsService.create(createTaskRequestDto);
    }
    update(updateTaskRequestDto) {
        this.taskRequestsService.update(updateTaskRequestDto);
    }
};
__decorate([
    common_1.Get(':id'),
    __param(0, common_1.Param()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], TaskRequestsController.prototype, "findOne", null);
__decorate([
    common_1.Get(),
    __param(0, common_1.Query('status')), __param(1, common_1.Query('limit')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Number]),
    __metadata("design:returntype", Array)
], TaskRequestsController.prototype, "findAll", null);
__decorate([
    common_1.Post(),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_request_dto_1.CreateTaskRequestDto]),
    __metadata("design:returntype", String)
], TaskRequestsController.prototype, "create", null);
__decorate([
    common_1.Put(),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_task_request_dto_1.UpdateTaskRequestDto]),
    __metadata("design:returntype", void 0)
], TaskRequestsController.prototype, "update", null);
TaskRequestsController = __decorate([
    common_1.Controller('task-requests'),
    __metadata("design:paramtypes", [task_requests_service_1.TaskRequestsService])
], TaskRequestsController);
exports.TaskRequestsController = TaskRequestsController;
