"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskRequestsGateway = void 0;
const common_1 = require("@nestjs/common");
const websockets_1 = require("@nestjs/websockets");
const socket_io_1 = require("socket.io");
const event_emitter_1 = require("@nestjs/event-emitter");
const create_task_request_dto_1 = require("./dto/create-task-request.dto");
const task_requests_service_1 = require("./task-requests.service");
const task_request_status_changed_event_1 = require("./events/task-request.status-changed.event");
let TaskRequestsGateway = class TaskRequestsGateway {
    // eslint-disable-next-line no-unused-vars
    constructor(taskRequestsService) {
        this.taskRequestsService = taskRequestsService;
        this.logger = new common_1.Logger('TaskRequestsGateway');
    }
    handleTaskRequest(createTaskRequestDto, client) {
        const id = this.taskRequestsService.create(Object.assign({}, createTaskRequestDto));
        client.emit('task-requests', { id });
    }
    handleTaskResult({ id }, client) {
        client.emit('task-results', this.taskRequestsService.getResult(id));
    }
    handleTaskRequestStatusChanged(event) {
        this.server.emit('task-statuses', { 'id': event.id, 'status': event.status });
    }
};
__decorate([
    websockets_1.WebSocketServer(),
    __metadata("design:type", socket_io_1.Server)
], TaskRequestsGateway.prototype, "server", void 0);
__decorate([
    websockets_1.SubscribeMessage('task-requests'),
    __param(0, websockets_1.MessageBody()), __param(1, websockets_1.ConnectedSocket()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_request_dto_1.CreateTaskRequestDto, socket_io_1.Socket]),
    __metadata("design:returntype", void 0)
], TaskRequestsGateway.prototype, "handleTaskRequest", null);
__decorate([
    websockets_1.SubscribeMessage('task-results'),
    __param(0, websockets_1.MessageBody()), __param(1, websockets_1.ConnectedSocket()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, socket_io_1.Socket]),
    __metadata("design:returntype", void 0)
], TaskRequestsGateway.prototype, "handleTaskResult", null);
__decorate([
    event_emitter_1.OnEvent('task-request.status-changed'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [task_request_status_changed_event_1.TaskRequestStatusChangedEvent]),
    __metadata("design:returntype", void 0)
], TaskRequestsGateway.prototype, "handleTaskRequestStatusChanged", null);
TaskRequestsGateway = __decorate([
    websockets_1.WebSocketGateway(),
    __metadata("design:paramtypes", [task_requests_service_1.TaskRequestsService])
], TaskRequestsGateway);
exports.TaskRequestsGateway = TaskRequestsGateway;
