import { EventEmitter2 } from '@nestjs/event-emitter';
import { GeneralTaskRequest } from './interfaces/task-request.interface';
import { CreateTaskRequestDto } from './dto/create-task-request.dto';
import { UpdateTaskRequestDto } from './dto/update-task-request.dto';
import { TaskProcessingResultDto } from './dto/task-processing-result.dto';
import { TaskRequestStatus } from './task-request-status';
export declare class TaskRequestsService {
    private eventEmitter;
    private readonly taskRequests;
    private id;
    private static readonly idLength;
    constructor(eventEmitter: EventEmitter2);
    private getNewId;
    create(createTaskRequestDto: CreateTaskRequestDto): string;
    update(updateTaskRequestDto: UpdateTaskRequestDto): void;
    findOne(id: string): GeneralTaskRequest;
    findAll(): GeneralTaskRequest[];
    findAllByStatus(status: TaskRequestStatus): GeneralTaskRequest[];
    getResult(id: string): TaskProcessingResultDto;
    delete(id: string): void;
}
