"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dotenv_1 = require("dotenv");
const mock_generation_1 = require("../lib/mock-utils/mock-generation");
const test_env_1 = require("../lib/test-env");
dotenv_1.config();
const brokerHost = process.env.BROKER_HOST || '127.0.0.1';
const brokerPort = process.env.BROKER_PORT || '3000';
const setupTestEnv = async () => {
    if (!(await test_env_1.checkEnvIsActive(brokerHost, brokerPort))) {
        const app = await test_env_1.bootstrapBroker(brokerHost, brokerPort);
        await test_env_1.bootstrapE1c(brokerHost, brokerPort);
        const e1cStarted = await test_env_1.checkEnvIsActive(brokerHost, brokerPort, 300000);
        if (!e1cStarted) {
            throw new Error('E1c start timeout (300s)');
        }
        // eslint-disable-next-line no-underscore-dangle
        global.__BROKER__ = app;
    }
    if (process.env.PATH_TO_EXTERNAL_BIN_FILE) {
        await mock_generation_1.generateMockedExternalBinFile(process.env.PATH_TO_EXTERNAL_BIN_FILE);
    }
};
exports.default = setupTestEnv;
