import { CreateTaskRequestDto } from '../../server/task-requests/dto/create-task-request.dto';
import { TaskProcessingResultDto } from '../../server/task-requests/dto/task-processing-result.dto';
import { TaskRequestParameterMap, TaskRequestType } from '../../server/task-requests/interfaces/task-request.interface';
export declare const sleep: (ms: number) => Promise<unknown>;
export declare const performTask: (taskRequest: CreateTaskRequestDto) => Promise<TaskProcessingResultDto>;
export declare type CreateTaskRequest<T extends TaskRequestType> = (params: TaskRequestParameterMap[T], performOnServer?: boolean) => CreateTaskRequestDto;
export declare const createEvaluateTaskRequest: CreateTaskRequest<'Evaluate'>;
export declare const createExecuteTaskRequest: CreateTaskRequest<'Execute'>;
export declare const createManagementTaskRequest: CreateTaskRequest<'Management'>;
export declare const createExecuteExternalTaskRequest: CreateTaskRequest<'ExecuteExternal'>;
